diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/mingw32-1.c gcc-3.4.4-3/gcc/config/i386/mingw32-1.c
--- gcc-3.4.4-3-orig/gcc/config/i386/mingw32-1.c	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/mingw32-1.c	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,41 @@
+/* This replaces the use of stat and struct stat.st_ino to determine if
+   files are different in gcc.c (do_spec_1) handling of --save-temps
+   switch.
+   Contributed by Danny Smith (dannysmith@users.sourceforge.net)
+   Copyright 2003 Free Software Foundation, Inc.
+
+This file is part of GCC.
+
+GCC is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version.
+
+GCC is distributed in the hope that it will be useful, but WITHOUT ANY
+WARRANTY; without even the implied warranty of MERCHANTABILITY or
+FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+for more details.
+
+You should have received a copy of the GNU General Public License
+along with GCC; see the file COPYING.  If not, write to the Free
+Software Foundation, 59 Temple Place - Suite 330, Boston, MA
+02111-1307, USA.  */
+
+#include "config/i386/xm-mingw32.h"
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+
+/* Return non-zero if src and dst filenames do not refer to same files. */
+
+int
+w32_file_id_cmp (const char * src, const char * dst)
+{
+  char fullpath_src[MAX_PATH];
+  char fullpath_dst[MAX_PATH];
+  char* pfilename;
+
+ /* Just compare full pathnames, without regard to case. */
+  GetFullPathName (src, MAX_PATH, fullpath_src, &pfilename);
+  GetFullPathName (dst, MAX_PATH, fullpath_dst, &pfilename);
+  return  (lstrcmpi (fullpath_src, fullpath_dst));
+}
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/mingw32.h gcc-3.4.4-3/gcc/config/i386/mingw32.h
--- gcc-3.4.4-3-orig/gcc/config/i386/mingw32.h	2003-09-26 04:46:06.000000000 +0100
+++ gcc-3.4.4-3/gcc/config/i386/mingw32.h	2005-06-03 21:03:36.000000000 +0100
@@ -67,7 +67,11 @@
 
 #undef STARTFILE_SPEC
 #define STARTFILE_SPEC "%{shared|mdll:dllcrt2%O%s} \
-  %{!shared:%{!mdll:crt2%O%s}} %{pg:gcrt2%O%s}"
+  %{!shared:%{!mdll:crt2%O%s}} %{pg:gcrt2%O%s}  \
+  %{!fno-exceptions:crtbegin%O%s}"
+
+#undef ENDFILE_SPEC
+#define ENDFILE_SPEC "%{!fno-exceptions:crtend%O%s}"
 
 /* An additional prefix to try after the standard prefixes.  */
 #undef MD_STARTFILE_PREFIX
@@ -104,3 +108,15 @@
 /* Define as short unsigned for compatibility with MS runtime.  */
 #undef WINT_TYPE
 #define WINT_TYPE "short unsigned int"
+
+/* MSVCRT does not support the "I" flag provided by GLIBC.  */
+#undef TARGET_EXTRA_PRINTF_FLAG_CHARS
+#define TARGET_EXTRA_PRINTF_FLAG_CHARS ""
+
+/* MSVCRT supports additional length specifiers for "printf".  (In
+   fact, it does not support some of the C99 specifiers, like
+   "ll".  However, we do not presently have a mechanism for disabling
+   a specifier.)  */  
+#define TARGET_EXTRA_PRINTF_LENGTH_SPECIFIERS	\
+  /* 64-bit integer */				\
+  { "I64", FMT_LEN_ll,   STD_EXT, NULL, 0, 0 }
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/pmm_malloc.h gcc-3.4.4-3/gcc/config/i386/pmm_malloc.h
--- gcc-3.4.4-3-orig/gcc/config/i386/pmm_malloc.h	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/pmm_malloc.h	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,56 @@
+/* Copyright (C) 2004 Free Software Foundation, Inc.
+
+   This file is part of GCC.
+
+   GCC is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   GCC is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with GCC; see the file COPYING.  If not, write to
+   the Free Software Foundation, 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.  */
+
+/* As a special exception, if you include this header file into source
+   files compiled by GCC, this header file does not by itself cause
+   the resulting executable to be covered by the GNU General Public
+   License.  This exception does not however invalidate any other
+   reasons why the executable file might be covered by the GNU General
+   Public License.  */
+
+#ifndef _MM_MALLOC_H_INCLUDED
+#define _MM_MALLOC_H_INCLUDED
+
+#include <stdlib.h>
+
+/* We can't depend on <stdlib.h> since the prototype of posix_memalign
+   may not be visible.  */
+extern int posix_memalign (void **, size_t, size_t);
+
+static __inline void *
+_mm_malloc (size_t size, size_t alignment)
+{
+  void *ptr;
+  if (alignment == 1)
+    return malloc (size);
+  if (alignment == 2 || (sizeof (void *) == 8 && alignment == 4))
+    alignment = sizeof (void *);
+  if (posix_memalign (&ptr, alignment, size) == 0)
+    return ptr;
+  else
+    return NULL;
+}
+
+static __inline void
+_mm_free (void * ptr)
+{
+  free (ptr);
+}
+
+#endif /* _MM_MALLOC_H_INCLUDED */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/t-cygming gcc-3.4.4-3/gcc/config/i386/t-cygming
--- gcc-3.4.4-3-orig/gcc/config/i386/t-cygming	2003-09-23 19:56:00.000000000 +0100
+++ gcc-3.4.4-3/gcc/config/i386/t-cygming	2006-05-13 17:35:16.000000000 +0100
@@ -10,6 +10,8 @@
 # first.
 LIBGCC2_INCLUDES = -I$(srcdir)/../winsup/w32api/include
 
+LIB2FUNCS_EXTRA = $(srcdir)/config/i386/w32-shared-ptr.c
+
 winnt.o: $(srcdir)/config/i386/winnt.c $(CONFIG_H) $(SYSTEM_H) coretypes.h \
   $(TM_H) $(RTL_H) $(REGS_H) hard-reg-set.h output.h $(TREE_H) flags.h \
   $(TM_P_H) toplev.h $(HASHTAB_H) $(GGC_H)
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/t-gmm_malloc gcc-3.4.4-3/gcc/config/i386/t-gmm_malloc
--- gcc-3.4.4-3-orig/gcc/config/i386/t-gmm_malloc	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/t-gmm_malloc	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,6 @@
+# Install gmm_malloc.h as mm_malloc.h.
+
+EXTRA_HEADERS += mm_malloc.h
+mm_malloc.h: $(srcdir)/config/i386/gmm_malloc.h
+	rm -f $@
+	cat $^ > $@
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/t-mingw32 gcc-3.4.4-3/gcc/config/i386/t-mingw32
--- gcc-3.4.4-3-orig/gcc/config/i386/t-mingw32	2002-06-11 06:25:44.000000000 +0100
+++ gcc-3.4.4-3/gcc/config/i386/t-mingw32	2005-06-03 21:03:36.000000000 +0100
@@ -1,7 +1,8 @@
 #
 # collect2 doesn't work for i386-mingw32* yet.
 #
-USE_COLLECT2=
+#USE_COLLECT2=
 
 # We hide calls to w32api needed for w32 thread support here:
-LIB2FUNCS_EXTRA = $(srcdir)/config/i386/gthr-win32.c
+LIB2FUNCS_EXTRA += $(srcdir)/config/i386/gthr-win32.c
+
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/t-pmm_malloc gcc-3.4.4-3/gcc/config/i386/t-pmm_malloc
--- gcc-3.4.4-3-orig/gcc/config/i386/t-pmm_malloc	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/t-pmm_malloc	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,6 @@
+# Install pmm_malloc.h as mm_malloc.h.
+
+EXTRA_HEADERS += mm_malloc.h
+mm_malloc.h: $(srcdir)/config/i386/pmm_malloc.h
+	rm -f $@
+	cat $^ > $@
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/w32-shared-ptr.c gcc-3.4.4-3/gcc/config/i386/w32-shared-ptr.c
--- gcc-3.4.4-3-orig/gcc/config/i386/w32-shared-ptr.c	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/w32-shared-ptr.c	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,248 @@
+/*
+ * w32-shared-ptr.c
+ *
+ * Share informations between EXE/DLLs without using an
+ * additional DLL.
+ *
+ * Contributors:
+ *  Created by Adriano dos Santos Fernandes <adrianosf@uol.com.br>
+ *  Enhanced by Thomas Pfaff <tpfaff@gmx.net>
+ *
+ *  THIS SOFTWARE IS NOT COPYRIGHTED
+ *
+ *  This source code is offered for use in the public domain. You may
+ *  use, modify or distribute it freely.
+ *
+ *  This code is distributed in the hope that it will be useful but
+ *  WITHOUT ANY WARRANTY. ALL WARRENTIES, EXPRESS OR IMPLIED ARE HEREBY
+ *  DISCLAMED. This includes but is not limited to warrenties of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ *
+ */
+
+#ifdef __MINGW32__
+#undef _CRTIMP
+#define _CRTIMP
+#endif
+
+#include <stdlib.h>
+#include <string.h>
+#ifdef __CYGWIN__
+#include <unistd.h>
+#endif
+#ifdef DEBUG
+#include <stdio.h>
+#endif
+
+#include "tconfig.h"
+#include "tsystem.h"
+#include "gthr.h"
+
+#include "w32-shared-ptr.h"
+
+#if defined (__CYGWIN__) /* FIXME: This shouldn't be necessary. */
+typedef unsigned short ATOM;
+ATOM __attribute__ ((stdcall)) AddAtomA(const char*);
+ATOM __attribute__  ((stdcall)) FindAtomA(const char*);
+unsigned int __attribute__  ((stdcall)) GetAtomNameA(ATOM,char*,int);
+#else
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+#endif
+
+#include <assert.h>
+
+W32_EH_SHARED *  __w32_sharedptr;
+
+void ** __w32_sharedptr_terminate;
+void ** __w32_sharedptr_unexpected;
+
+
+#define W32_ATOM_SUFFIX "-LIBGCCW32-EH"
+
+#define VERSION_SUFFIX "-2"
+
+#ifdef __USING_SJLJ_EXCEPTIONS__
+#define SJLJ_SUFFIX "-SJLJ"
+#else
+#define SJLJ_SUFFIX
+#endif
+
+#if __GTHREADS
+#define GTHR_SUFFIX "-GTHR"
+#else
+#define GTHR_SUFFIX
+#endif
+
+#ifdef __CYGWIN__
+#define SYS_SUFFIX "-CYGWIN"
+#else
+#define SYS_SUFFIX "-MINGW32"
+#endif
+
+static const char w32_atom_suffix[]
+  = W32_ATOM_SUFFIX VERSION_SUFFIX SJLJ_SUFFIX GTHR_SUFFIX SYS_SUFFIX;
+
+#define SHAREDPTR_BIT1          'A'
+#define SHAREDPTR_BIT0          'a'
+
+#define SHAREDPTR_BITS          (sizeof(W32_EH_SHARED*)*8)
+#define SHARED_ATOM_NAME_LEN    (SHAREDPTR_BITS + sizeof(w32_atom_suffix))
+
+static ATOM __w32_sharedptr_set (W32_EH_SHARED *w32_sharedptr);
+static W32_EH_SHARED * __w32_sharedptr_get (ATOM atom);
+static void __w32_sharedptr_default_unexpected(void);
+
+#ifdef __CYGWIN__
+static void __w32_sharedptr_fixup_after_fork (void);
+#endif
+
+static void __w32_sharedptr_default_unexpected(void)
+{
+  ((void(*)(void))__w32_sharedptr->terminate)();
+}
+
+static void __w32_eh_shared_initialize (W32_EH_SHARED *w32_sharedptr)
+{
+#ifdef __GTHREAD_MUTEX_INIT
+  static __gthread_mutex_t dw2_object_mutex = __GTHREAD_MUTEX_INIT;
+#else
+  static __gthread_mutex_t dw2_object_mutex;
+#endif
+#ifdef __GTHREAD_MUTEX_INIT_FUNCTION
+  static __gthread_once_t dw2_once = __GTHREAD_ONCE_INIT;
+#endif
+
+#ifdef __USING_SJLJ_EXCEPTIONS__ 
+#if __GTHREADS
+  static __gthread_key_t sjl_fc_key;
+  static __gthread_once_t sjl_once = __GTHREAD_ONCE_INIT;
+#endif
+#endif
+
+  memset (w32_sharedptr, 0, sizeof(W32_EH_SHARED));
+
+  w32_sharedptr->size = sizeof(W32_EH_SHARED);
+
+  w32_sharedptr->terminate = (void*)abort;
+  w32_sharedptr->unexpected = (void*)__w32_sharedptr_default_unexpected;
+
+  w32_sharedptr->dw2_object_mutex = dw2_object_mutex;
+#ifdef __GTHREAD_MUTEX_INIT_FUNCTION
+  w32_sharedptr->dw2_once = dw2_once;
+#endif
+
+#ifdef __USING_SJLJ_EXCEPTIONS__
+  w32_sharedptr->sjlj_fc_static = NULL;
+#if __GTHREADS
+  w32_sharedptr->sjlj_fc_key = sjl_fc_key;
+  w32_sharedptr->sjlj_use_fc_key = -1;
+  w32_sharedptr->sjlj_once = sjl_once;
+#endif
+#endif
+}
+
+void __w32_sharedptr_initialize (void) 
+{
+  W32_EH_SHARED *w32_sharedptr;
+  char s[SHARED_ATOM_NAME_LEN];
+  ATOM atom;
+
+  if (__w32_sharedptr)
+    return;
+
+  memset (s, SHAREDPTR_BIT1, SHAREDPTR_BITS);
+  memcpy (&(s[SHAREDPTR_BITS]), w32_atom_suffix, sizeof(w32_atom_suffix));
+
+  atom = FindAtomA (s);
+  if (atom)
+    w32_sharedptr = __w32_sharedptr_get (atom);
+  else
+    {
+      w32_sharedptr = (W32_EH_SHARED *) malloc (sizeof(W32_EH_SHARED));
+      if (!w32_sharedptr)
+        abort ();
+
+      __w32_eh_shared_initialize (w32_sharedptr);
+
+      if (__w32_sharedptr_set (w32_sharedptr))
+        {
+#ifdef __CYGWIN__
+          /* recreate atom after fork */
+          pthread_atfork (NULL,NULL,__w32_sharedptr_fixup_after_fork);
+#endif
+        }
+      else
+        {
+          free (w32_sharedptr);
+          w32_sharedptr = __w32_sharedptr_get (FindAtomA (s));
+        }
+    }
+
+  __w32_sharedptr_terminate  = &w32_sharedptr->terminate;
+  __w32_sharedptr_unexpected = &w32_sharedptr->unexpected;
+
+  /* THIS MUST BE THE LAST STEP */
+  __w32_sharedptr = w32_sharedptr;
+}
+
+static ATOM __w32_sharedptr_set (W32_EH_SHARED *w32_sharedptr)
+{
+  int i;
+  int bit;
+  char s[SHARED_ATOM_NAME_LEN];
+  ATOM atom;
+
+  /* This should optimize out entirely by O2 */
+  if (sizeof(bit) != sizeof(w32_sharedptr))
+    abort ();
+
+  for (i = SHAREDPTR_BITS - 1, bit = 1; i >= 0; --i, bit <<= 1)
+    s[i] = ((int)w32_sharedptr) & bit ? SHAREDPTR_BIT1 :
+      SHAREDPTR_BIT0;
+
+  memcpy (&(s[SHAREDPTR_BITS]), w32_atom_suffix, sizeof(w32_atom_suffix));
+
+  atom = AddAtomA (s);
+  /* Sanity check to avoid race by concurrent initialization */
+  if (!atom || __w32_sharedptr_get (atom) != w32_sharedptr)
+    return 0;
+
+#ifdef DEBUG
+  printf ("%s: set sharedptr: (%p):%s\n",
+          __FUNCTION__,w32_sharedptr, s);
+#endif
+
+  return atom;
+}
+
+static W32_EH_SHARED *__w32_sharedptr_get (ATOM atom)
+{
+  W32_EH_SHARED *w32_sharedptr;
+  int i;
+  int bit;
+  int address = 0;
+  char s[SHARED_ATOM_NAME_LEN];
+
+  /* If this fails something went wrong */
+   assert (GetAtomNameA (atom, s, sizeof(s)) != 0);
+
+  for (i = SHAREDPTR_BITS - 1, bit = 1; i >= 0; --i, bit <<= 1)
+    address |= s[i] == SHAREDPTR_BIT1 ? bit : 0;
+  w32_sharedptr = (W32_EH_SHARED*) address;
+
+  assert (w32_sharedptr->size == sizeof(W32_EH_SHARED));
+
+#ifdef DEBUG
+  printf ("%s: got sharedptr (%p): %s\n",
+          __FUNCTION__, w32_sharedptr, s);
+#endif
+  return w32_sharedptr;
+}
+
+#ifdef __CYGWIN__
+static void __w32_sharedptr_fixup_after_fork (void)
+{
+  assert (__w32_sharedptr_set (__w32_sharedptr) != 0);
+}
+#endif
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/config/i386/w32-shared-ptr.h gcc-3.4.4-3/gcc/config/i386/w32-shared-ptr.h
--- gcc-3.4.4-3-orig/gcc/config/i386/w32-shared-ptr.h	1970-01-01 00:00:00.000000000 +0000
+++ gcc-3.4.4-3/gcc/config/i386/w32-shared-ptr.h	2005-06-03 21:03:44.000000000 +0100
@@ -0,0 +1,65 @@
+/*
+ * w32-shared-ptr.h
+ *
+ * Contributors:
+ *  Created by Thomas Pfaff <tpfaff@gmx.net>
+ *
+ *  THIS SOFTWARE IS NOT COPYRIGHTED
+ *
+ *  This source code is offered for use in the public domain. You may
+ *  use, modify or distribute it freely.
+ *
+ *  This code is distributed in the hope that it will be useful but
+ *  WITHOUT ANY WARRANTY. ALL WARRENTIES, EXPRESS OR IMPLIED ARE HEREBY
+ *  DISCLAMED. This includes but is not limited to warrenties of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ *
+ */
+
+#ifndef GCC_W32_SHARED_PTR_H
+#define GCC_W32_SHARED_PTR_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct
+{
+  int size;
+  
+  void *terminate;
+  void *unexpected;
+
+  void *dw2_unseen_objects;
+  void *dw2_seen_objects;
+  __gthread_mutex_t dw2_object_mutex;
+#ifdef __GTHREAD_MUTEX_INIT_FUNCTION
+  __gthread_once_t dw2_once;
+#endif
+  void *dw2_marker;
+
+#ifdef __USING_SJLJ_EXCEPTIONS__ 
+  void* sjlj_fc_static;
+#if __GTHREADS
+  __gthread_key_t sjlj_fc_key;
+  int sjlj_use_fc_key;
+  __gthread_once_t sjlj_once;
+#endif
+#endif
+
+} W32_EH_SHARED;
+
+extern W32_EH_SHARED *__w32_sharedptr;
+
+extern void ** __w32_sharedptr_terminate;
+extern void ** __w32_sharedptr_unexpected;
+
+extern void __w32_sharedptr_initialize (void);
+
+#define W32_SHAREDPTR_INITIALIZE()  if (!__w32_sharedptr) __w32_sharedptr_initialize ()
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
